searchData={"items":[{"type":"module","title":"ExOauth2Provider","doc":"A module that provides OAuth 2 capabilities for Elixir applications.","ref":"ExOauth2Provider.html"},{"type":"module","title":"Configuration - ExOauth2Provider","doc":"config :my_app, ExOauth2Provider,\n      repo: App.Repo,\n      resource_owner: App.Users.User,\n      default_scopes: ~w(public),\n      optional_scopes: ~w(write update),\n      native_redirect_uri: \"urn:ietf:wg:oauth:2.0:oob\",\n      authorization_code_expires_in: 600,\n      access_token_expires_in: 7200,\n      use_refresh_token: false,\n      revoke_refresh_token_on_use: false,\n      force_ssl_in_redirect_uri: true,\n      grant_flows: ~w(authorization_code client_credentials),\n      password_auth: nil,\n      access_token_response_body_handler: nil\n\nIf `revoke_refresh_token_on_use` is set to true,\nrefresh tokens will be revoked after a related access token is used.\n\nIf `revoke_refresh_token_on_use` is not set to true,\nprevious tokens are revoked as soon as a new access token is created.\n\nIf `use_refresh_token` is set to true, the refresh_token grant flow\nis automatically enabled.\n\nIf `password_auth` is set to a {module, method} tuple, the password\ngrant flow is automatically enabled.\n\nIf access_token_expires_in is set to nil, access tokens will never\nexpire.","ref":"ExOauth2Provider.html#module-configuration"},{"type":"function","title":"ExOauth2Provider.authenticate_token/2","doc":"Authenticate an access token.","ref":"ExOauth2Provider.html#authenticate_token/2"},{"type":"function","title":"Example - ExOauth2Provider.authenticate_token/2","doc":"ExOauth2Provider.authenticate_token(\"Jf5rM8hQBc\", otp_app: :my_app)","ref":"ExOauth2Provider.html#authenticate_token/2-example"},{"type":"function","title":"Response - ExOauth2Provider.authenticate_token/2","doc":"{:ok, access_token}\n    {:error, reason}","ref":"ExOauth2Provider.html#authenticate_token/2-response"},{"type":"module","title":"ExOauth2Provider.AccessGrants","doc":"The boundary for the OauthAccessGrants system.","ref":"ExOauth2Provider.AccessGrants.html"},{"type":"function","title":"ExOauth2Provider.AccessGrants.create_grant/4","doc":"Creates an access grant.","ref":"ExOauth2Provider.AccessGrants.html#create_grant/4"},{"type":"function","title":"Examples - ExOauth2Provider.AccessGrants.create_grant/4","doc":"iex> create_grant(resource_owner, application, attrs)\n    {:ok, %OauthAccessGrant{}}\n\n    iex> create_grant(resource_owner, application, attrs)\n    {:error, %Ecto.Changeset{}}","ref":"ExOauth2Provider.AccessGrants.html#create_grant/4-examples"},{"type":"function","title":"ExOauth2Provider.AccessGrants.get_active_grant_for/3","doc":"Gets a single access grant registered with an application.","ref":"ExOauth2Provider.AccessGrants.html#get_active_grant_for/3"},{"type":"function","title":"Examples - ExOauth2Provider.AccessGrants.get_active_grant_for/3","doc":"iex> get_active_grant_for(application, \"jE9dk\", otp_app: :my_app)\n    %OauthAccessGrant{}\n\n    iex> get_active_grant_for(application, \"jE9dk\", otp_app: :my_app)\n    ** nil","ref":"ExOauth2Provider.AccessGrants.html#get_active_grant_for/3-examples"},{"type":"function","title":"ExOauth2Provider.AccessGrants.revoke/2","doc":"","ref":"ExOauth2Provider.AccessGrants.html#revoke/2"},{"type":"function","title":"ExOauth2Provider.AccessGrants.revoke!/2","doc":"","ref":"ExOauth2Provider.AccessGrants.html#revoke!/2"},{"type":"module","title":"ExOauth2Provider.AccessGrants.AccessGrant","doc":"Handles the Ecto schema for access grant.","ref":"ExOauth2Provider.AccessGrants.AccessGrant.html"},{"type":"module","title":"Usage - ExOauth2Provider.AccessGrants.AccessGrant","doc":"Configure `lib/my_project/oauth_access_grants/oauth_access_grant.ex` the following way:\n\n    defmodule MyApp.OauthAccessGrants.OauthAccessGrant do\n      use Ecto.Schema\n      use ExOauth2Provider.AccessGrants.AccessGrant\n\n      schema \"oauth_access_grants\" do\n        access_grant_fields()\n\n        timestamps()\n      end\n    end","ref":"ExOauth2Provider.AccessGrants.AccessGrant.html#module-usage"},{"type":"macro","title":"ExOauth2Provider.AccessGrants.AccessGrant.access_grant_fields/0","doc":"","ref":"ExOauth2Provider.AccessGrants.AccessGrant.html#access_grant_fields/0"},{"type":"function","title":"ExOauth2Provider.AccessGrants.AccessGrant.changeset/3","doc":"","ref":"ExOauth2Provider.AccessGrants.AccessGrant.html#changeset/3"},{"type":"function","title":"ExOauth2Provider.AccessGrants.AccessGrant.put_token/1","doc":"","ref":"ExOauth2Provider.AccessGrants.AccessGrant.html#put_token/1"},{"type":"type","title":"ExOauth2Provider.AccessGrants.AccessGrant.t/0","doc":"","ref":"ExOauth2Provider.AccessGrants.AccessGrant.html#t:t/0"},{"type":"module","title":"ExOauth2Provider.AccessTokens","doc":"Ecto schema for oauth access tokens","ref":"ExOauth2Provider.AccessTokens.html"},{"type":"function","title":"ExOauth2Provider.AccessTokens.create_application_token/3","doc":"Creates an application access token.","ref":"ExOauth2Provider.AccessTokens.html#create_application_token/3"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.create_application_token/3","doc":"iex> create_application_token(application, %{scopes: \"read write\"}, otp_app: :my_app)\n    {:ok, %OauthAccessToken{}}","ref":"ExOauth2Provider.AccessTokens.html#create_application_token/3-examples"},{"type":"function","title":"ExOauth2Provider.AccessTokens.create_token/3","doc":"Creates an access token.","ref":"ExOauth2Provider.AccessTokens.html#create_token/3"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.create_token/3","doc":"iex> create_token(resource_owner, %{application: application, scopes: \"read write\"}, otp_app: :my_app)\n    {:ok, %OauthAccessToken{}}\n\n    iex> create_token(resource_owner, %{scopes: \"read write\"}, otp_app: :my_app)\n    {:ok, %OauthAccessToken{}}\n\n    iex> create_token(resource_owner, %{expires_in: \"invalid\"}, otp_app: :my_app)\n    {:error, %Ecto.Changeset{}}","ref":"ExOauth2Provider.AccessTokens.html#create_token/3-examples"},{"type":"function","title":"ExOauth2Provider.AccessTokens.get_application_token_for/3","doc":"Gets the most recent, acccessible, matching access token for an application.","ref":"ExOauth2Provider.AccessTokens.html#get_application_token_for/3"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.get_application_token_for/3","doc":"iex> get_application_token_for(application, \"read write\", otp_app: :my_app)\n    %OauthAccessToken{}\n\n    iex> get_application_token_for(application, \"read invalid\", otp_app: :my_app)\n    nil","ref":"ExOauth2Provider.AccessTokens.html#get_application_token_for/3-examples"},{"type":"function","title":"ExOauth2Provider.AccessTokens.get_authorized_tokens_for/2","doc":"Gets all authorized access tokens for resource owner.","ref":"ExOauth2Provider.AccessTokens.html#get_authorized_tokens_for/2"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.get_authorized_tokens_for/2","doc":"iex> get_authorized_tokens_for(resource_owner, otp_app: :my_app)\n    [%OauthAccessToken{}, ...]","ref":"ExOauth2Provider.AccessTokens.html#get_authorized_tokens_for/2-examples"},{"type":"function","title":"ExOauth2Provider.AccessTokens.get_by_previous_refresh_token_for/2","doc":"Gets an old access token by previous refresh token.","ref":"ExOauth2Provider.AccessTokens.html#get_by_previous_refresh_token_for/2"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.get_by_previous_refresh_token_for/2","doc":"iex> get_by_previous_refresh_token_for(new_access_token, otp_app: :my_app)\n    %OauthAccessToken{}\n\n    iex> get_by_previous_refresh_token_for(new_access_token, otp_app: :my_app)\n    nil","ref":"ExOauth2Provider.AccessTokens.html#get_by_previous_refresh_token_for/2-examples"},{"type":"function","title":"ExOauth2Provider.AccessTokens.get_by_refresh_token/2","doc":"Gets an access token by the refresh token.","ref":"ExOauth2Provider.AccessTokens.html#get_by_refresh_token/2"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.get_by_refresh_token/2","doc":"iex> get_by_refresh_token(\"c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d\", otp_app: :my_app)\n    %OauthAccessToken{}\n\n    iex> get_by_refresh_token(\"75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc\", otp_app: :my_app)\n    nil","ref":"ExOauth2Provider.AccessTokens.html#get_by_refresh_token/2-examples"},{"type":"function","title":"ExOauth2Provider.AccessTokens.get_by_refresh_token_for/3","doc":"Gets an access token by the refresh token belonging to an application.","ref":"ExOauth2Provider.AccessTokens.html#get_by_refresh_token_for/3"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.get_by_refresh_token_for/3","doc":"iex> get_by_refresh_token_for(application, \"c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d\", otp_app: :my_app)\n    %OauthAccessToken{}\n\n    iex> get_by_refresh_token_for(application, \"75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc\", otp_app: :my_app)\n    nil","ref":"ExOauth2Provider.AccessTokens.html#get_by_refresh_token_for/3-examples"},{"type":"function","title":"ExOauth2Provider.AccessTokens.get_by_token/2","doc":"Gets a single access token.","ref":"ExOauth2Provider.AccessTokens.html#get_by_token/2"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.get_by_token/2","doc":"iex> get_by_token(\"c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d\", otp_app: :my_app)\n    %OauthAccessToken{}\n\n    iex> get_by_token(\"75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc\", otp_app: :my_app)\n    nil","ref":"ExOauth2Provider.AccessTokens.html#get_by_token/2-examples"},{"type":"function","title":"ExOauth2Provider.AccessTokens.get_token_for/4","doc":"Gets the most recent, acccessible, matching access token for a resource owner.","ref":"ExOauth2Provider.AccessTokens.html#get_token_for/4"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.get_token_for/4","doc":"iex> get_token_for(resource_owner, application, \"read write\", otp_app: :my_app)\n    %OauthAccessToken{}\n\n    iex> get_token_for(resource_owner, application, \"read invalid\", otp_app: :my_app)\n    nil","ref":"ExOauth2Provider.AccessTokens.html#get_token_for/4-examples"},{"type":"function","title":"ExOauth2Provider.AccessTokens.is_accessible?/1","doc":"Checks if an access token can be accessed.","ref":"ExOauth2Provider.AccessTokens.html#is_accessible?/1"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.is_accessible?/1","doc":"iex> is_accessible?(token)\n    true\n\n    iex> is_accessible?(inaccessible_token)\n    false","ref":"ExOauth2Provider.AccessTokens.html#is_accessible?/1-examples"},{"type":"function","title":"ExOauth2Provider.AccessTokens.is_expired?/1","doc":"","ref":"ExOauth2Provider.AccessTokens.html#is_expired?/1"},{"type":"function","title":"ExOauth2Provider.AccessTokens.is_revoked?/1","doc":"","ref":"ExOauth2Provider.AccessTokens.html#is_revoked?/1"},{"type":"function","title":"ExOauth2Provider.AccessTokens.revoke/2","doc":"","ref":"ExOauth2Provider.AccessTokens.html#revoke/2"},{"type":"function","title":"ExOauth2Provider.AccessTokens.revoke!/2","doc":"","ref":"ExOauth2Provider.AccessTokens.html#revoke!/2"},{"type":"function","title":"ExOauth2Provider.AccessTokens.revoke_previous_refresh_token/2","doc":"Revokes token with `refresh_token` equal to\n`previous_refresh_token` and clears `:previous_refresh_token`\nattribute.","ref":"ExOauth2Provider.AccessTokens.html#revoke_previous_refresh_token/2"},{"type":"function","title":"Examples - ExOauth2Provider.AccessTokens.revoke_previous_refresh_token/2","doc":"iex> revoke_previous_refresh_token(data, otp_app: :my_app)\n    {:ok, %OauthAccessToken{}}\n\n    iex> revoke_previous_refresh_token(invalid_data, otp_app: :my_app)\n    {:error, %Ecto.Changeset{}}","ref":"ExOauth2Provider.AccessTokens.html#revoke_previous_refresh_token/2-examples"},{"type":"module","title":"ExOauth2Provider.AccessTokens.AccessToken","doc":"Handles the Ecto schema for access token.","ref":"ExOauth2Provider.AccessTokens.AccessToken.html"},{"type":"module","title":"Usage - ExOauth2Provider.AccessTokens.AccessToken","doc":"Configure `lib/my_project/oauth_access_tokens/oauth_access_token.ex` the following way:\n\n    defmodule MyApp.OauthAccessTokens.OauthAccessToken do\n      use Ecto.Schema\n      use ExOauth2Provider.AccessTokens.AccessToken\n\n      schema \"oauth_access_tokens\" do\n        access_token_fields()\n\n        timestamps()\n      end\n    end","ref":"ExOauth2Provider.AccessTokens.AccessToken.html#module-usage"},{"type":"macro","title":"ExOauth2Provider.AccessTokens.AccessToken.access_token_fields/0","doc":"","ref":"ExOauth2Provider.AccessTokens.AccessToken.html#access_token_fields/0"},{"type":"function","title":"ExOauth2Provider.AccessTokens.AccessToken.changeset/3","doc":"","ref":"ExOauth2Provider.AccessTokens.AccessToken.html#changeset/3"},{"type":"type","title":"ExOauth2Provider.AccessTokens.AccessToken.t/0","doc":"","ref":"ExOauth2Provider.AccessTokens.AccessToken.html#t:t/0"},{"type":"module","title":"ExOauth2Provider.Applications","doc":"The boundary for the applications system.","ref":"ExOauth2Provider.Applications.html"},{"type":"function","title":"ExOauth2Provider.Applications.change_application/3","doc":"Create application changeset.","ref":"ExOauth2Provider.Applications.html#change_application/3"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.change_application/3","doc":"iex> change_application(application, %{}, otp_app: :my_app)\n    {:ok, %OauthApplication{}}","ref":"ExOauth2Provider.Applications.html#change_application/3-examples"},{"type":"function","title":"ExOauth2Provider.Applications.create_application/3","doc":"Creates an application.","ref":"ExOauth2Provider.Applications.html#create_application/3"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.create_application/3","doc":"iex> create_application(user, %{name: \"App\", redirect_uri: \"http://example.com\"}, otp_app: :my_app)\n    {:ok, %OauthApplication{}}\n\n    iex> create_application(user, %{name: \"\"}, otp_app: :my_app)\n    {:error, %Ecto.Changeset{}}","ref":"ExOauth2Provider.Applications.html#create_application/3-examples"},{"type":"function","title":"ExOauth2Provider.Applications.delete_application/2","doc":"Deletes an application.","ref":"ExOauth2Provider.Applications.html#delete_application/2"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.delete_application/2","doc":"iex> delete_application(application, otp_app: :my_app)\n    {:ok, %OauthApplication{}}\n\n    iex> delete_application(application, otp_app: :my_app)\n    {:error, %Ecto.Changeset{}}","ref":"ExOauth2Provider.Applications.html#delete_application/2-examples"},{"type":"function","title":"ExOauth2Provider.Applications.get_application/2","doc":"Gets a single application by uid.","ref":"ExOauth2Provider.Applications.html#get_application/2"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.get_application/2","doc":"iex> get_application(\"c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d\", otp_app: :my_app)\n    %OauthApplication{}\n\n    iex> get_application(\"75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc\", otp_app: :my_app)\n    nil","ref":"ExOauth2Provider.Applications.html#get_application/2-examples"},{"type":"function","title":"ExOauth2Provider.Applications.get_application!/2","doc":"Gets a single application by uid.\n\nRaises `Ecto.NoResultsError` if the Application does not exist.","ref":"ExOauth2Provider.Applications.html#get_application!/2"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.get_application!/2","doc":"iex> get_application!(\"c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d\", otp_app: :my_app)\n    %OauthApplication{}\n\n    iex> get_application!(\"75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc\", otp_app: :my_app)\n    ** (Ecto.NoResultsError)","ref":"ExOauth2Provider.Applications.html#get_application!/2-examples"},{"type":"function","title":"ExOauth2Provider.Applications.get_application_for!/3","doc":"Gets a single application for a resource owner.\n\nRaises `Ecto.NoResultsError` if the OauthApplication does not exist for resource owner.","ref":"ExOauth2Provider.Applications.html#get_application_for!/3"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.get_application_for!/3","doc":"iex> get_application_for!(owner, \"c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d\", otp_app: :my_app)\n    %OauthApplication{}\n\n    iex> get_application_for!(owner, \"75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc\", otp_app: :my_app)\n    ** (Ecto.NoResultsError)","ref":"ExOauth2Provider.Applications.html#get_application_for!/3-examples"},{"type":"function","title":"ExOauth2Provider.Applications.get_applications_for/2","doc":"Returns all applications for a owner.","ref":"ExOauth2Provider.Applications.html#get_applications_for/2"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.get_applications_for/2","doc":"iex> get_applications_for(resource_owner, otp_app: :my_app)\n    [%OauthApplication{}, ...]","ref":"ExOauth2Provider.Applications.html#get_applications_for/2-examples"},{"type":"function","title":"ExOauth2Provider.Applications.get_authorized_applications_for/2","doc":"Gets all authorized applications for a resource owner.","ref":"ExOauth2Provider.Applications.html#get_authorized_applications_for/2"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.get_authorized_applications_for/2","doc":"iex> get_authorized_applications_for(owner, otp_app: :my_app)\n    [%OauthApplication{},...]","ref":"ExOauth2Provider.Applications.html#get_authorized_applications_for/2-examples"},{"type":"function","title":"ExOauth2Provider.Applications.load_application/3","doc":"Gets a single application by uid and secret.","ref":"ExOauth2Provider.Applications.html#load_application/3"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.load_application/3","doc":"iex> load_application(\"c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d\", \"SECRET\", otp_app: :my_app)\n    %OauthApplication{}\n\n    iex> load_application(\"75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc\", \"SECRET\", otp_app: :my_app)\n    nil","ref":"ExOauth2Provider.Applications.html#load_application/3-examples"},{"type":"function","title":"ExOauth2Provider.Applications.revoke_all_access_tokens_for/3","doc":"Revokes all access tokens for an application and resource owner.","ref":"ExOauth2Provider.Applications.html#revoke_all_access_tokens_for/3"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.revoke_all_access_tokens_for/3","doc":"iex> revoke_all_access_tokens_for(application, resource_owner, otp_app: :my_app)\n    {:ok, [ok: %OauthAccessToken{}]}","ref":"ExOauth2Provider.Applications.html#revoke_all_access_tokens_for/3-examples"},{"type":"function","title":"ExOauth2Provider.Applications.update_application/3","doc":"Updates an application.","ref":"ExOauth2Provider.Applications.html#update_application/3"},{"type":"function","title":"Examples - ExOauth2Provider.Applications.update_application/3","doc":"iex> update_application(application, %{name: \"Updated App\"}, otp_app: :my_app)\n    {:ok, %OauthApplication{}}\n\n    iex> update_application(application, %{name: \"\"}, otp_app: :my_app)\n    {:error, %Ecto.Changeset{}}","ref":"ExOauth2Provider.Applications.html#update_application/3-examples"},{"type":"module","title":"ExOauth2Provider.Applications.Application","doc":"Handles the Ecto schema for application.","ref":"ExOauth2Provider.Applications.Application.html"},{"type":"module","title":"Usage - ExOauth2Provider.Applications.Application","doc":"Configure `lib/my_project/oauth_applications/oauth_application.ex` the following way:\n\n    defmodule MyApp.OauthApplications.OauthApplication do\n      use Ecto.Schema\n      use ExOauth2Provider.Applications.Application\n\n      schema \"oauth_applications\" do\n        application_fields()\n\n        timestamps()\n      end\n    end","ref":"ExOauth2Provider.Applications.Application.html#module-usage"},{"type":"module","title":"Application owner - ExOauth2Provider.Applications.Application","doc":"By default the application owner will be will be the `:resource_owner`\nconfiguration setting. You can override this by overriding the `:owner`\nbelongs to association:\n\n    defmodule MyApp.OauthApplications.OauthApplication do\n      use Ecto.Schema\n      use ExOauth2Provider.Applications.Application\n\n      schema \"oauth_applications\" do\n        belongs_to :owner, MyApp.Users.User\n\n        application_fields()\n\n        timestamps()\n      end\n    end","ref":"ExOauth2Provider.Applications.Application.html#module-application-owner"},{"type":"macro","title":"ExOauth2Provider.Applications.Application.application_fields/0","doc":"","ref":"ExOauth2Provider.Applications.Application.html#application_fields/0"},{"type":"function","title":"ExOauth2Provider.Applications.Application.changeset/3","doc":"","ref":"ExOauth2Provider.Applications.Application.html#changeset/3"},{"type":"type","title":"ExOauth2Provider.Applications.Application.t/0","doc":"","ref":"ExOauth2Provider.Applications.Application.html#t:t/0"},{"type":"module","title":"ExOauth2Provider.Authorization","doc":"Handler for dealing with generating access grants.","ref":"ExOauth2Provider.Authorization.html"},{"type":"function","title":"ExOauth2Provider.Authorization.authorize/3","doc":"Check ExOauth2Provider.Authorization.Code for usage.","ref":"ExOauth2Provider.Authorization.html#authorize/3"},{"type":"function","title":"ExOauth2Provider.Authorization.deny/3","doc":"Check ExOauth2Provider.Authorization.Code for usage.","ref":"ExOauth2Provider.Authorization.html#deny/3"},{"type":"function","title":"ExOauth2Provider.Authorization.preauthorize/3","doc":"Check ExOauth2Provider.Authorization.Code for usage.","ref":"ExOauth2Provider.Authorization.html#preauthorize/3"},{"type":"module","title":"ExOauth2Provider.Authorization.Code","doc":"Methods for authorization code flow.\n\nThe flow consists of three method calls:\n\n1. `preauthorize(resource_owner, request)`\n\nThis validates the request. If a resource owner already have been\nauthenticated previously it'll respond with a redirect tuple.\n\n2. `authorize(resource_owner, request)`\n\nThis confirms a resource owner authorization, and will generate an access\ntoken.\n\n3. `deny(resource_owner, request)`\n\nThis rejects a resource owner authorization.\n\n---\n\nIn a controller it could look like this:\n\n```elixir\nalias ExOauth2Provider.Authorization\n\ndef new(conn, params) do\n  case Authorization.preauthorize(current_resource_owner(conn), params) do\n    {:ok, client, scopes} ->\n      render(conn, \"new.html\", params: params, client: client, scopes: scopes)\n    {:native_redirect, %{code: code}} ->\n      redirect(conn, to: oauth_authorization_path(conn, :show, code))\n    {:redirect, redirect_uri} ->\n      redirect(conn, external: redirect_uri)\n    {:error, error, status} ->\n      conn\n      |> put_status(status)\n      |> render(\"error.html\", error: error)\n  end\nend\n\ndef create(conn, params) do\n  conn\n  |> current_resource_owner\n  |> Authorization.authorize(params)\n  |> redirect_or_render(conn)\nend\n\ndef delete(conn, params) do\n  conn\n  |> current_resource_owner\n  |> Authorization.deny(params)\n  |> redirect_or_render(conn)\nend\n```","ref":"ExOauth2Provider.Authorization.Code.html"},{"type":"function","title":"ExOauth2Provider.Authorization.Code.authorize/3","doc":"Authorizes an authorization code flow request.\n\nThis is used when a resource owner has authorized access. If successful,\nthis will generate an access token grant.","ref":"ExOauth2Provider.Authorization.Code.html#authorize/3"},{"type":"function","title":"Example - ExOauth2Provider.Authorization.Code.authorize/3","doc":"resource_owner\n    |> ExOauth2Provider.Authorization.authorize(%{\n      \"client_id\" => \"Jf5rM8hQBc\",\n      \"response_type\" => \"code\",\n      \"scope\" => \"read write\",                  # Optional\n      \"state\" => \"46012\",                       # Optional\n      \"redirect_uri\" => \"https://example.com/\"  # Optional\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Authorization.Code.html#authorize/3-example"},{"type":"function","title":"Response - ExOauth2Provider.Authorization.Code.authorize/3","doc":"{:ok, code}                                                  # A grant was generated\n    {:error, %{error: error, error_description: _}, http_status} # Error occurred\n    {:redirect, redirect_uri}                                    # Redirect\n    {:native_redirect, %{code: code}}                            # Redirect to :show page","ref":"ExOauth2Provider.Authorization.Code.html#authorize/3-response"},{"type":"function","title":"ExOauth2Provider.Authorization.Code.deny/3","doc":"Rejects an authorization code flow request.\n\nThis is used when a resource owner has rejected access.","ref":"ExOauth2Provider.Authorization.Code.html#deny/3"},{"type":"function","title":"Example - ExOauth2Provider.Authorization.Code.deny/3","doc":"resource_owner\n    |> ExOauth2Provider.Authorization.deny(%{\n      \"client_id\" => \"Jf5rM8hQBc\",\n      \"response_type\" => \"code\"\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Authorization.Code.html#deny/3-example"},{"type":"function","title":"Response type - ExOauth2Provider.Authorization.Code.deny/3","doc":"{:error, %{error: error, error_description: _}, http_status} # Error occurred\n    {:redirect, redirect_uri}                                    # Redirect","ref":"ExOauth2Provider.Authorization.Code.html#deny/3-response-type"},{"type":"function","title":"ExOauth2Provider.Authorization.Code.preauthorize/3","doc":"Validates an authorization code flow request.\n\nWill check if there's already an existing access token with same scope and client\nfor the resource owner.","ref":"ExOauth2Provider.Authorization.Code.html#preauthorize/3"},{"type":"function","title":"Example - ExOauth2Provider.Authorization.Code.preauthorize/3","doc":"resource_owner\n    |> ExOauth2Provider.Authorization.preauthorize(%{\n      \"client_id\" => \"Jf5rM8hQBc\",\n      \"response_type\" => \"code\"\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Authorization.Code.html#preauthorize/3-example"},{"type":"function","title":"Response - ExOauth2Provider.Authorization.Code.preauthorize/3","doc":"{:ok, client, scopes}                                         # Show request page with client and scopes\n    {:error, %{error: error, error_description: _}, http_status}  # Show error page with error and http status\n    {:redirect, redirect_uri}                                     # Redirect\n    {:native_redirect, %{code: code}}                             # Redirect to :show page","ref":"ExOauth2Provider.Authorization.Code.html#preauthorize/3-response"},{"type":"module","title":"ExOauth2Provider.Plug","doc":"ExOauth2Provider.Plug contains functions that assist with interacting with\nExOauth2Provider via Plugs.\n\nExOauth2Provider.Plug is not itself a plug.\n\nUse the helpers to look up current_access_token and current_resource_owner.","ref":"ExOauth2Provider.Plug.html"},{"type":"module","title":"Example - ExOauth2Provider.Plug","doc":"ExOauth2Provider.Plug.current_access_token(conn)\n    ExOauth2Provider.Plug.current_resource_owner(conn)","ref":"ExOauth2Provider.Plug.html#module-example"},{"type":"function","title":"ExOauth2Provider.Plug.authenticated?/2","doc":"Check if a request is authenticated","ref":"ExOauth2Provider.Plug.html#authenticated?/2"},{"type":"function","title":"ExOauth2Provider.Plug.current_access_token/2","doc":"Fetch the currently verified token from the request.\nOptionally located at a key","ref":"ExOauth2Provider.Plug.html#current_access_token/2"},{"type":"function","title":"ExOauth2Provider.Plug.current_resource_owner/2","doc":"Fetch the currently authenticated resource if loaded,\noptionally located at a key","ref":"ExOauth2Provider.Plug.html#current_resource_owner/2"},{"type":"module","title":"ExOauth2Provider.Plug.EnsureAuthenticated","doc":"This plug ensures that the request has been authenticated with an access token.\n\nIf one is not found, the `unauthenticated/2` function is invoked with the\n`Plug.Conn.t` object and its params.","ref":"ExOauth2Provider.Plug.EnsureAuthenticated.html"},{"type":"module","title":"Example - ExOauth2Provider.Plug.EnsureAuthenticated","doc":"# Will call the unauthenticated/2 function on your handler\n    plug ExOauth2Provider.Plug.EnsureAuthenticated, handler: SomeModule\n\n    # look in the :secret location.  You can also do simple claim checks:\n    plug ExOauth2Provider.Plug.EnsureAuthenticated, handler: SomeModule, key: :secret\n\n    plug ExOauth2Provider.Plug.EnsureAuthenticated, handler: SomeModule, typ: \"access\"\n\nIf the handler option is not passed, `ExOauth2Provider.Plug.ErrorHandler` will provide\nthe default behavior.","ref":"ExOauth2Provider.Plug.EnsureAuthenticated.html#module-example"},{"type":"module","title":"ExOauth2Provider.Plug.EnsureScopes","doc":"Use this plug to ensure that there are the correct scopes on\nthe token found on the connection.\n\n#","ref":"ExOauth2Provider.Plug.EnsureScopes.html"},{"type":"module","title":"Example - ExOauth2Provider.Plug.EnsureScopes","doc":"alias ExOauth2Provider.Plug.EnsureScopes\n\n    # With custom handler\n    plug EnsureScopes, scopes: ~w(read write), handler: SomeMod,\n\n    # item:read AND item:write scopes AND :profile scope\n    plug EnsureScopes, scopes: ~(item:read item:write profile)\n\n    # iteam:read AND item: write scope OR :profile for the default set\n    plug EnsureScopes, one_of: [~(item:read item:write),\n                                ~(profile)]\n\n    # item :read AND :write for the token located in the :secret location\n    plug EnsureScopes, key: :secret, scopes: ~(read :write)\n\n   If the handler option is not passed, `ExOauth2Provider.Plug.ErrorHandler`\n   will provide the default behavior.","ref":"ExOauth2Provider.Plug.EnsureScopes.html#module-example"},{"type":"behaviour","title":"ExOauth2Provider.Plug.ErrorHandler","doc":"A default error handler that can be used for failed authentication","ref":"ExOauth2Provider.Plug.ErrorHandler.html"},{"type":"callback","title":"ExOauth2Provider.Plug.ErrorHandler.no_resource/2","doc":"","ref":"ExOauth2Provider.Plug.ErrorHandler.html#c:no_resource/2"},{"type":"callback","title":"ExOauth2Provider.Plug.ErrorHandler.unauthenticated/2","doc":"","ref":"ExOauth2Provider.Plug.ErrorHandler.html#c:unauthenticated/2"},{"type":"callback","title":"ExOauth2Provider.Plug.ErrorHandler.unauthorized/2","doc":"","ref":"ExOauth2Provider.Plug.ErrorHandler.html#c:unauthorized/2"},{"type":"module","title":"ExOauth2Provider.Plug.VerifyHeader","doc":"Use this plug to authenticate a token contained in the header.\nYou should set the value of the Authorization header to:\n    Authorization:","ref":"ExOauth2Provider.Plug.VerifyHeader.html"},{"type":"module","title":"Example - ExOauth2Provider.Plug.VerifyHeader","doc":"plug ExOauth2Provider.Plug.VerifyHeader, otp_app: :my_app\n\nA \"realm\" can be specified when using the plug.\nRealms are like the name of the token and allow many tokens\nto be sent with a single request.\n\n    plug ExOauth2Provider.Plug.VerifyHeader, otp_app: :my_app, realm: \"Bearer\"\n\nWhen a realm is not specified, the first authorization header\nfound is used, and assumed to be a raw token\n\n##","ref":"ExOauth2Provider.Plug.VerifyHeader.html#module-example"},{"type":"module","title":"example - ExOauth2Provider.Plug.VerifyHeader","doc":"plug ExOauth2Provider.Plug.VerifyHeader, otp_app: :my_app\n\n    # will take the first auth header\n    # Authorization:","ref":"ExOauth2Provider.Plug.VerifyHeader.html#module-example"},{"type":"module","title":"ExOauth2Provider.RedirectURI","doc":"Functions for dealing with redirect uri.","ref":"ExOauth2Provider.RedirectURI.html"},{"type":"function","title":"ExOauth2Provider.RedirectURI.matches?/3","doc":"Check if uri matches client uri","ref":"ExOauth2Provider.RedirectURI.html#matches?/3"},{"type":"function","title":"ExOauth2Provider.RedirectURI.native_redirect_uri?/2","doc":"Check if a url is native","ref":"ExOauth2Provider.RedirectURI.html#native_redirect_uri?/2"},{"type":"function","title":"ExOauth2Provider.RedirectURI.uri_with_query/2","doc":"Adds query parameters to uri","ref":"ExOauth2Provider.RedirectURI.html#uri_with_query/2"},{"type":"function","title":"ExOauth2Provider.RedirectURI.valid_for_authorization?/3","doc":"Check if a url matches a client redirect_uri","ref":"ExOauth2Provider.RedirectURI.html#valid_for_authorization?/3"},{"type":"function","title":"ExOauth2Provider.RedirectURI.validate/2","doc":"Validates if a url can be used as a redirect_uri.\n\nValidates according to [RFC 6749 3.1.2](https://tools.ietf.org/html/rfc6749#section-3.1.2)\nand [RFC 8252 7.1](https://tools.ietf.org/html/rfc8252#section-7.1). The validation is\nskipped if the redirect uri is the same as the `:native_redirect_uri` configuration\nsetting.","ref":"ExOauth2Provider.RedirectURI.html#validate/2"},{"type":"module","title":"ExOauth2Provider.Schema","doc":"This module will permit dynamic App.Schema load.","ref":"ExOauth2Provider.Schema.html"},{"type":"module","title":"ExOauth2Provider.Scopes","doc":"Functions for dealing with scopes.","ref":"ExOauth2Provider.Scopes.html"},{"type":"function","title":"ExOauth2Provider.Scopes.all?/2","doc":"Check if required scopes exists in the scopes list","ref":"ExOauth2Provider.Scopes.html#all?/2"},{"type":"function","title":"ExOauth2Provider.Scopes.default_to_server_scopes/2","doc":"Will default to server scopes if no scopes supplied","ref":"ExOauth2Provider.Scopes.html#default_to_server_scopes/2"},{"type":"function","title":"ExOauth2Provider.Scopes.equal?/2","doc":"Check if two lists of scopes are equal","ref":"ExOauth2Provider.Scopes.html#equal?/2"},{"type":"function","title":"ExOauth2Provider.Scopes.filter_default_scopes/2","doc":"Filter defaults scopes from scopes list","ref":"ExOauth2Provider.Scopes.html#filter_default_scopes/2"},{"type":"function","title":"ExOauth2Provider.Scopes.from_access_token/1","doc":"Fetch scopes from an access token","ref":"ExOauth2Provider.Scopes.html#from_access_token/1"},{"type":"function","title":"ExOauth2Provider.Scopes.to_list/1","doc":"Convert scopes string to list","ref":"ExOauth2Provider.Scopes.html#to_list/1"},{"type":"function","title":"ExOauth2Provider.Scopes.to_string/1","doc":"Convert scopes list to string","ref":"ExOauth2Provider.Scopes.html#to_string/1"},{"type":"module","title":"ExOauth2Provider.Token","doc":"Handler for dealing with generating access tokens.","ref":"ExOauth2Provider.Token.html"},{"type":"function","title":"ExOauth2Provider.Token.grant/2","doc":"Grants an access token based on grant_type strategy.","ref":"ExOauth2Provider.Token.html#grant/2"},{"type":"function","title":"Example - ExOauth2Provider.Token.grant/2","doc":"ExOauth2Provider.Token.authorize(resource_owner, %{\n      \"grant_type\" => \"invalid\",\n      \"client_id\" => \"Jf5rM8hQBc\",\n      \"client_secret\" => \"secret\"\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Token.html#grant/2-example"},{"type":"function","title":"Response - ExOauth2Provider.Token.grant/2","doc":"{:error, %{error: error, error_description: description}, http_status}","ref":"ExOauth2Provider.Token.html#grant/2-response"},{"type":"function","title":"ExOauth2Provider.Token.revoke/2","doc":"Revokes an access token as per http://tools.ietf.org/html/rfc7009","ref":"ExOauth2Provider.Token.html#revoke/2"},{"type":"function","title":"Example - ExOauth2Provider.Token.revoke/2","doc":"ExOauth2Provider.Token.revoke(resource_owner, %{\n      \"client_id\" => \"Jf5rM8hQBc\",\n      \"client_secret\" => \"secret\",\n      \"token\" => \"fi3S9u\"\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Token.html#revoke/2-example"},{"type":"function","title":"Response - ExOauth2Provider.Token.revoke/2","doc":"{:ok, %{}}","ref":"ExOauth2Provider.Token.html#revoke/2-response"},{"type":"module","title":"ExOauth2Provider.Token.AuthorizationCode","doc":"Functions for dealing with authorization code strategy.","ref":"ExOauth2Provider.Token.AuthorizationCode.html"},{"type":"function","title":"ExOauth2Provider.Token.AuthorizationCode.grant/2","doc":"Will grant access token by client credentials.","ref":"ExOauth2Provider.Token.AuthorizationCode.html#grant/2"},{"type":"function","title":"Example - ExOauth2Provider.Token.AuthorizationCode.grant/2","doc":"ExOauth2Provider.Token.grant(%{\n      \"code\" => \"1jf6a\",\n      \"client_id\" => \"Jf5rM8hQBc\",\n      \"client_secret\" => \"secret\",\n      \"redirect_uri\" => \"https://example.com/\",\n      \"grant_type\" => \"authorization_code\"\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Token.AuthorizationCode.html#grant/2-example"},{"type":"function","title":"Response - ExOauth2Provider.Token.AuthorizationCode.grant/2","doc":"{:ok, access_token}\n    {:error, %{error: error, error_description: description}, http_status}","ref":"ExOauth2Provider.Token.AuthorizationCode.html#grant/2-response"},{"type":"module","title":"ExOauth2Provider.Token.ClientCredentials","doc":"Functions for dealing with client credentials strategy.","ref":"ExOauth2Provider.Token.ClientCredentials.html"},{"type":"function","title":"ExOauth2Provider.Token.ClientCredentials.grant/2","doc":"Will grant access token by client credentials.","ref":"ExOauth2Provider.Token.ClientCredentials.html#grant/2"},{"type":"function","title":"Example - ExOauth2Provider.Token.ClientCredentials.grant/2","doc":"ExOauth2Provider.Token.grant(%{\n      \"grant_type\" => \"client_credentials\",\n      \"client_id\" => \"Jf5rM8hQBc\",\n      \"client_secret\" => \"secret\"\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Token.ClientCredentials.html#grant/2-example"},{"type":"function","title":"Response - ExOauth2Provider.Token.ClientCredentials.grant/2","doc":"{:ok, access_token}\n    {:error, %{error: error, error_description: description}, http_status}","ref":"ExOauth2Provider.Token.ClientCredentials.html#grant/2-response"},{"type":"module","title":"ExOauth2Provider.Token.Password","doc":"Functions for dealing with refresh token strategy.","ref":"ExOauth2Provider.Token.Password.html"},{"type":"function","title":"ExOauth2Provider.Token.Password.grant/2","doc":"Will grant access token by password authentication.","ref":"ExOauth2Provider.Token.Password.html#grant/2"},{"type":"function","title":"Example - ExOauth2Provider.Token.Password.grant/2","doc":"ExOauth2Provider.Token.grant(%{\n      \"grant_type\" => \"password\",\n      \"client_id\" => \"Jf5rM8hQBc\",\n      \"client_secret\" => \"secret\",\n      \"username\" => \"testuser@example.com\",\n      \"password\" => \"secret\"\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Token.Password.html#grant/2-example"},{"type":"function","title":"Response - ExOauth2Provider.Token.Password.grant/2","doc":"{:ok, access_token}\n    {:error, %{error: error, error_description: description}, http_status}","ref":"ExOauth2Provider.Token.Password.html#grant/2-response"},{"type":"module","title":"ExOauth2Provider.Token.RefreshToken","doc":"Functions for dealing with refresh token strategy.","ref":"ExOauth2Provider.Token.RefreshToken.html"},{"type":"function","title":"ExOauth2Provider.Token.RefreshToken.grant/2","doc":"Will grant access token by refresh token.","ref":"ExOauth2Provider.Token.RefreshToken.html#grant/2"},{"type":"function","title":"Example - ExOauth2Provider.Token.RefreshToken.grant/2","doc":"ExOauth2Provider.Token.authorize(%{\n      \"grant_type\" => \"refresh_token\",\n      \"client_id\" => \"Jf5rM8hQBc\",\n      \"client_secret\" => \"secret\",\n      \"refresh_token\" => \"1jf6a\"\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Token.RefreshToken.html#grant/2-example"},{"type":"function","title":"Response - ExOauth2Provider.Token.RefreshToken.grant/2","doc":"{:ok, access_token}\n    {:error, %{error: error, error_description: description}, http_status}","ref":"ExOauth2Provider.Token.RefreshToken.html#grant/2-response"},{"type":"module","title":"ExOauth2Provider.Token.Revoke","doc":"Functions for dealing with revocation.","ref":"ExOauth2Provider.Token.Revoke.html"},{"type":"function","title":"ExOauth2Provider.Token.Revoke.revoke/2","doc":"Revokes access token.\n\nThe authorization server, if applicable, first authenticates the client\nand checks its ownership of the provided token.\n\nExOauth2Provider does not use the token_type_hint logic described in the\nRFC 7009 due to the refresh token implementation that is a field in\nthe access token schema.","ref":"ExOauth2Provider.Token.Revoke.html#revoke/2"},{"type":"function","title":"Example confidential client - ExOauth2Provider.Token.Revoke.revoke/2","doc":"ExOauth2Provider.Token.revoke(%{\n      \"client_id\" => \"Jf5rM8hQBc\",\n      \"client_secret\" => \"secret\",\n      \"token\" => \"fi3S9u\"\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Token.Revoke.html#revoke/2-example-confidential-client"},{"type":"function","title":"Response - ExOauth2Provider.Token.Revoke.revoke/2","doc":"{:ok, %{}}","ref":"ExOauth2Provider.Token.Revoke.html#revoke/2-response"},{"type":"function","title":"Example public client - ExOauth2Provider.Token.Revoke.revoke/2","doc":"ExOauth2Provider.Token.revoke(%{\n      \"token\" => \"fi3S9u\"\n    }, otp_app: :my_app)","ref":"ExOauth2Provider.Token.Revoke.html#revoke/2-example-public-client"},{"type":"function","title":"Response - ExOauth2Provider.Token.Revoke.revoke/2","doc":"{:ok, %{}}","ref":"ExOauth2Provider.Token.Revoke.html#revoke/2-response"},{"type":"module","title":"Mix.ExOauth2Provider","doc":"Utilities module for mix tasks.","ref":"Mix.ExOauth2Provider.html"},{"type":"function","title":"Mix.ExOauth2Provider.no_umbrella!/1","doc":"Raises an exception if the project is an umbrella app.","ref":"Mix.ExOauth2Provider.html#no_umbrella!/1"},{"type":"function","title":"Mix.ExOauth2Provider.otp_app/0","doc":"","ref":"Mix.ExOauth2Provider.html#otp_app/0"},{"type":"function","title":"Mix.ExOauth2Provider.parse_options/3","doc":"Parses argument options into a map.","ref":"Mix.ExOauth2Provider.html#parse_options/3"},{"type":"module","title":"Mix.ExOauth2Provider.Migration","doc":"Utilities module for ecto migrations in mix tasks.","ref":"Mix.ExOauth2Provider.Migration.html"},{"type":"function","title":"Mix.ExOauth2Provider.Migration.create_migration_file/3","doc":"Creates a migration file for a repo.","ref":"Mix.ExOauth2Provider.Migration.html#create_migration_file/3"},{"type":"function","title":"Mix.ExOauth2Provider.Migration.gen/3","doc":"","ref":"Mix.ExOauth2Provider.Migration.html#gen/3"},{"type":"task","title":"mix ex_oauth2_provider","doc":"Prints ExOauth2Provider tasks and their information.\n    mix ex_oauth2_provider","ref":"Mix.Tasks.ExOauth2Provider.html"},{"type":"task","title":"mix ex_oauth2_provider.gen.migration","doc":"Generates migration file.\n\n    mix ex_oauth2_provider.gen.migrations -r MyApp.Repo\n\n    mix ex_oauth2_provider.gen.migrations -r MyApp.Repo --namespace oauth2\n\nThis generator will add the oauth2 migration file in `priv/repo/migrations`.\n\nThe repository must be set under `:ecto_repos` in the current app\nconfiguration or given via the `-r` option.\n\nBy default, the migration will be generated to the\n\"priv/YOUR_REPO/migrations\" directory of the current application but it\ncan be configured to be any subdirectory of `priv` by specifying the\n`:priv` key under the repository configuration.","ref":"Mix.Tasks.ExOauth2Provider.Gen.Migration.html"},{"type":"task","title":"Arguments - mix ex_oauth2_provider.gen.migration","doc":"* `-r`, `--repo` - the repo module\n  * `--binary-id` - use binary id for primary keys\n  * `--namespace` - namespace to prepend table and schema module name","ref":"Mix.Tasks.ExOauth2Provider.Gen.Migration.html#module-arguments"},{"type":"task","title":"mix ex_oauth2_provider.gen.schemas","doc":"Generates schema files.\n\n    mix ex_oauth2_provider.gen.schemas\n\n    mix ex_oauth2_provider.gen.schemas --binary-id --namespace oauth2","ref":"Mix.Tasks.ExOauth2Provider.Gen.Schemas.html"},{"type":"task","title":"Arguments - mix ex_oauth2_provider.gen.schemas","doc":"* `--binary-id` - use binary id for primary keys\n  * `--namespace` - namespace to prepend table and schema module name\n  * `--context-app` - context app to use for path and module names","ref":"Mix.Tasks.ExOauth2Provider.Gen.Schemas.html#module-arguments"},{"type":"task","title":"mix ex_oauth2_provider.install","doc":"Generates migrations, schema module files, and updates config.\n\n      mix ex_oauth2_provider.install\n\n      mix ex_oauth2_provider.install --no-schemas","ref":"Mix.Tasks.ExOauth2Provider.Install.html"},{"type":"task","title":"Arguments - mix ex_oauth2_provider.install","doc":"* `--context-app` - context app to use for path and module names\n  * `--no-migration` - don't create migration file\n  * `--no-schemas` - don't create schema module files","ref":"Mix.Tasks.ExOauth2Provider.Install.html#module-arguments"},{"type":"extras","title":"ExOauth2Provider","doc":"# ExOauth2Provider\n\n[![Build Status](https://travis-ci.org/danschultzer/ex_oauth2_provider.svg?branch=master)](https://travis-ci.org/danschultzer/ex_oauth2_provider) [![hex.pm](http://img.shields.io/hexpm/v/ex_oauth2_provider.svg?style=flat)](https://hex.pm/packages/ex_oauth2_provider) [![hex.pm downloads](https://img.shields.io/hexpm/dt/ex_oauth2_provider.svg?style=flat)](https://hex.pm/packages/ex_oauth2_provider)\n\nThe no-brainer library to use for adding OAuth 2.0 provider capabilities to your Elixir app. You can use [phoenix_oauth2_provider](https://github.com/danschultzer/phoenix_oauth2_provider) for easy integration with your Phoenix app.","ref":"readme.html"},{"type":"extras","title":"Installation - ExOauth2Provider","doc":"Add ExOauth2Provider to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    # ...\n    {:ex_oauth2_provider, \"~> 0.5.7\"}\n    # ...\n  ]\nend\n```\n\nRun `mix deps.get` to install it.","ref":"readme.html#installation"},{"type":"extras","title":"Getting started - ExOauth2Provider","doc":"Generate the migrations and schema modules:\n\n```bash\nmix ex_oauth2_provider.install\n```\n\nAdd the following to `config/config.exs`:\n\n```elixir\nconfig :my_app, ExOauth2Provider,\n  repo: MyApp.Repo,\n  resource_owner: MyApp.Users.User\n```\n\nIf you don't have any user setup, you shuld consider setting up [`Pow`](https://github.com/danschultzer/pow) first.","ref":"readme.html#getting-started"},{"type":"extras","title":"Authorize code flow - ExOauth2Provider","doc":"#","ref":"readme.html#authorize-code-flow"},{"type":"extras","title":"Authorization request - ExOauth2Provider","doc":"You have to ensure that a `resource_owner` has been authenticated on the following endpoints, and pass the struct as the first argument in the following methods.\n\n```elixir\n# GET /oauth/authorize?response_type=code&client_id=CLIENT_ID&redirect_uri=CALLBACK_URL&scope=read\ncase ExOauth2Provider.Authorization.preauthorize(resource_owner, params, otp_app: :my_app) do\n  {:ok, client, scopes}             -> # render authorization page\n  {:redirect, redirect_uri}         -> # redirect to external redirect_uri\n  {:native_redirect, %{code: code}} -> # redirect to local :show endpoint\n  {:error, error, http_status}      -> # render error page\nend\n\n# POST /oauth/authorize?response_type=code&client_id=CLIENT_ID&redirect_uri=CALLBACK_URL&scope=read\nExOauth2Provider.Authorization.authorize(resource_owner, params, otp_app: :my_app) do\n  {:redirect, redirect_uri}         -> # redirect to external redirect_uri\n  {:native_redirect, %{code: code}} -> # redirect to local :show endpoint\n  {:error, error, http_status}      -> # render error page\nend\n\n# DELETE /oauth/authorize?response_type=code&client_id=CLIENT_ID&redirect_uri=CALLBACK_URL&scope=read\nExOauth2Provider.Authorization.deny(resource_owner, params, otp_app: :my_app) do\n  {:redirect, redirect_uri}         -> # redirect to external redirect_uri\n  {:error, error, http_status}      -> # render error page\nend\n```\n\n#","ref":"readme.html#authorization-request"},{"type":"extras","title":"Authorization code grant - ExOauth2Provider","doc":"```elixir\n# POST /oauth/token?client_id=CLIENT_ID&client_secret=CLIENT_SECRET&grant_type=authorization_code&code=AUTHORIZATION_CODE&redirect_uri=CALLBACK_URL\ncase ExOauth2Provider.Token.grant(params, otp_app: :my_app) do\n  {:ok, access_token}               -> # JSON response\n  {:error, error, http_status}      -> # JSON response\nend\n```\n\n#","ref":"readme.html#authorization-code-grant"},{"type":"extras","title":"Revocation - ExOauth2Provider","doc":"```elixir\n# GET /oauth/revoke?client_id=CLIENT_ID&client_secret=CLIENT_SECRET&token=ACCESS_TOKEN\ncase ExOauth2Provider.Token.revoke(params, otp_app: :my_app) do\n  {:ok, %{}}                        -> # JSON response\n  {:error, error, http_status}      -> # JSON response\nend\n```\n\nRevocation will return `{:ok, %{}}` status even if the token is invalid.\n\n#","ref":"readme.html#revocation"},{"type":"extras","title":"Authorization code flow in a Single Page Application - ExOauth2Provider","doc":"ExOauth2Provider doesn't support **implicit** grant flow. Instead you should set up an application with no client secret, and use the **Authorize code** grant flow. `client_secret` isn't required unless it has been set for the application.\n\n#","ref":"readme.html#authorization-code-flow-in-a-single-page-application"},{"type":"extras","title":"Other supported token grants - ExOauth2Provider","doc":"##","ref":"readme.html#other-supported-token-grants"},{"type":"extras","title":"Client credentials - ExOauth2Provider","doc":"```elixir\n# POST /oauth/token?client_id=CLIENT_ID&client_secret=CLIENT_SECRET&grant_type=client_credentials\ncase ExOauth2Provider.Token.grant(params, otp_app: :my_app) do\n  {:ok, access_token}               -> # JSON response\n  {:error, error, http_status}      -> # JSON response\nend\n```\n\n##","ref":"readme.html#client-credentials"},{"type":"extras","title":"Refresh token - ExOauth2Provider","doc":"Refresh tokens can be enabled in the configuration:\n\n```elixir\nconfig :my_app, ExOauth2Provider,\n  repo: MyApp.Repo,\n  resource_owner: MyApp.Users.User,\n  use_refresh_token: true\n```\n\nThe `refresh_token` grant flow will then be enabled.\n\n```elixir\n# POST /oauth/token?client_id=CLIENT_ID&client_secret=CLIENT_SECRET&grant_type=refresh_token&refresh_token=REFRESH_TOKEN\ncase ExOauth2Provider.Token.grant(params, otp_app: :my_app) do\n  {:ok, access_token}               -> # JSON response\n  {:error, error, http_status}      -> # JSON response\nend\n```\n\n##","ref":"readme.html#refresh-token"},{"type":"extras","title":"Username and password - ExOauth2Provider","doc":"You'll need to provide an authorization method that accepts username and password as arguments, and returns `{:ok, resource_owner}` or `{:error, reason}`. Here'a an example:\n\n```elixir\n# Configuration in config/config.exs\nconfig :my_app, ExOauth2Provider,\n  password_auth: {Auth, :authenticate}\n\n# Module example\ndefmodule Auth do\n  def authenticate(username, password, otp_app: :my_app) do\n    User\n    |> Repo.get_by(email: username)\n    |> verify_password(password)\n  end\n\n  defp verify_password(nil, password) do\n    check_pw(\"\", password) # Prevent timing attack\n\n    {:error, :no_user_found}\n  end\n  defp verify_password(%{password_hash: password_hash} = user, password) do\n    case check_pw(password_hash, password) do\n      true  -> {:ok, user}\n      false -> {:error, :invalid_password}\n    end\n  end\nend\n```\n\nThe `password` grant flow will then be enabled.\n\n```elixir\n# POST /oauth/token?client_id=CLIENT_ID&grant_type=password&username=USERNAME&password=PASSWORD\ncase ExOauth2Provider.Token.grant(params, otp_app: :my_app) do\n  {:ok, access_token}               -> # JSON response\n  {:error, error, http_status}      -> # JSON response\nend\n```","ref":"readme.html#username-and-password"},{"type":"extras","title":"Scopes - ExOauth2Provider","doc":"Server wide scopes can be defined in the configuration:\n\n```elixir\nconfig :my_app, ExOauth2Provider,\n  repo: MyApp.Repo,\n  resource_owner: MyApp.Users.User,\n  default_scopes: ~w(public),\n  optional_scopes: ~w(read update)\n```","ref":"readme.html#scopes"},{"type":"extras","title":"Plug API - ExOauth2Provider","doc":"### [ExOauth2Provider.Plug.VerifyHeader](lib/ex_oauth2_provider/plug/verify_header.ex)\n\nLooks for a token in the Authorization Header. If one is not found, this does nothing. This will always be necessary to run to load access token and resource owner.\n\n### [ExOauth2Provider.Plug.EnsureAuthenticated](lib/ex_oauth2_provider/plug/ensure_authenticated.ex)\n\nLooks for a verified token loaded by [`VerifyHeader`](#exoauth2providerplugverifyheader). If one is not found it will call the `:unauthenticated` method in the `:handler` module.\n\nYou can use a custom `:handler` as part of a pipeline, or inside a Phoenix controller like so:\n\n```elixir\ndefmodule MyAppWeb.MyController do\n  use MyAppWeb, :controller\n\n  plug ExOauth2Provider.Plug.EnsureAuthenticated,\n    handler: MyAppWeb.MyAuthErrorHandler\nend\n```\n\n The `:handler` module always defaults to [ExOauth2Provider.Plug.ErrorHandler](lib/ex_oauth2_provider/plug/error_handler.ex).\n\n### [ExOauth2Provider.Plug.EnsureScopes](lib/ex_oauth2_provider/plug/ensure_scopes.ex)\n\nLooks for a previously verified token. If one is found, confirms that all listed scopes are present in the token. If not, the `:unauthorized` function is called on your `:handler`.\n\n```elixir\ndefmodule MyAppWeb.MyController do\n  use MyAppWeb, :controller\n\n  plug ExOauth2Provider.Plug.EnsureScopes,\n    handler: MyAppWeb.MyAuthErrorHandler, scopes: ~w(read write)\nend\n```\n\nWhen scopes' sets are specified through a `:one_of` map, the token is searched for at least one matching scopes set to allow the request. The first set that matches will allow the request. If no set matches, the `:unauthorized` function is called.\n\n```elixir\ndefmodule MyAppWeb.MyController do\n  use MyAppWeb, :controller\n\n  plug ExOauth2Provider.Plug.EnsureScopes,\n    handler: MyAppWeb.MyAuthErrorHandler,\n    one_of: [~w(admin), ~w(read write)]\nend\n```\n\n#","ref":"readme.html#plug-api"},{"type":"extras","title":"Current resource owner and access token - ExOauth2Provider","doc":"If the Authorization Header was verified, you'll be able to retrieve the current resource owner or access token.\n\n```elixir\nExOauth2Provider.Plug.current_access_token(conn) # access the token in the `:default` location\nExOauth2Provider.Plug.current_access_token(conn, :custom) # access the token in the `:custom` location if set as `:key` option in `plug ExOauth2Provider.Plug.VerifyHeader`\n```\n\n```elixir\nExOauth2Provider.Plug.current_resource_owner(conn) # Access the loaded resource owner in the `:default` location\nExOauth2Provider.Plug.current_resource_owner(conn, :custom) # Access the loaded resource owner in the `:secret` location if set as `:key` option in `plug ExOauth2Provider.Plug.VerifyHeader`\n```\n\n#","ref":"readme.html#current-resource-owner-and-access-token"},{"type":"extras","title":"Custom access token generator - ExOauth2Provider","doc":"You can add your own access token generator, as this example shows:\n\n```elixir\n# config/config.exs\nconfig :my_app, ExOauth2Provider,\n  access_token_generator: {AccessToken, :new}\n\ndefmodule AccessToken\n  def new(access_token) do\n    with_signer(%JWT.token{\n      resource_owner_id: access_token.resource_owner_id,\n      application_id: access_token.application.id,\n      scopes: access_token.scopes,\n      expires_in: access_token.expires_in,\n      created_at: access_token.created_at\n    }, hs256(\"my_secret\"))\n  end\nend\n```\n\nRemember to change the field type for the `token` column in the `oauth_access_tokens` table to accepts tokens larger than 255 characters.\n\n#","ref":"readme.html#custom-access-token-generator"},{"type":"extras","title":"Custom access token response body - ExOauth2Provider","doc":"You can add extra values to the response body.\n\n```elixir\n# config/config.exs\nconfig :my_app, ExOauth2Provider,\n  access_token_response_body_handler: {CustomResponse, :response}\n\ndefmodule CustomResponse\n  def response(response_body, access_token) do\n    Map.merge(response_body, %{user_id: access_token.resource_owner.id})\n  end\nend\n```\n\nRemember to change the field type for the `token` column in the `oauth_access_tokens` table to accepts tokens larger than 255 characters.","ref":"readme.html#custom-access-token-response-body"},{"type":"extras","title":"Using binary id - ExOauth2Provider","doc":"#","ref":"readme.html#using-binary-id"},{"type":"extras","title":"Generate migration file with binary id - ExOauth2Provider","doc":"You'll need to create the migration file and schema modules with the argument `--binary-id`:\n\n```bash\nmix ex_oauth2_provider.install --binary-id\n```","ref":"readme.html#generate-migration-file-with-binary-id"},{"type":"extras","title":"Acknowledgement - ExOauth2Provider","doc":"This library was made thanks to [doorkeeper](https://github.com/doorkeeper-gem/doorkeeper), [guardian](https://github.com/ueberauth/guardian) and [authable](https://github.com/mustafaturan/authable), that gave the conceptual building blocks.\n\nThanks to [Benjamin Schultzer](https://github.com/schultzer) for helping to refactor the code.","ref":"readme.html#acknowledgement"},{"type":"extras","title":"LICENSE - ExOauth2Provider","doc":"(The MIT License)\n\nCopyright (c) 2017-2019 Dan Schultzer & the Contributors\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#license"}],"content_type":"text/markdown"}